package hu.bme.mit.books.manager;

import java.util.List;

import hu.bme.mit.books.model.Book;

import org.eclipse.core.databinding.observable.list.ObservableList;
import org.eclipse.core.databinding.observable.list.WritableList;

/**
 * An interface for managing books.
 * 
 */
public interface IBookManager {

	/**
	 * Adds a single book to the manager. The addition does not check whether
	 * the book is already added.
	 * 
	 * @param author
	 * @param title
	 * @param pages
	 * @param read
	 */
	public void addBook(String author, String title, int pages, boolean read);

	public void addBook(Book book);

	public void removeBook(Book book);

	public WritableList/* <Book> */observeAllBooks();

	public List<Book> getAllBooks();

	/**
	 * Returns a list of books of a selected author. The author name must
	 * neither be null nor empty.
	 * 
	 * @param name
	 * @return the collected list of book by the selected author
	 * @throws IllegalArgumentException if the author name is not set 
	 */
	List<Book> getBookOfAuthor(String name) throws IllegalArgumentException;

}
